/*PLUGIN_SDAL_SS_SPEC
(c) by Sir Drink a lot

Makes a screenshot for the client AND for the admin who is spectating the client.
Screenshots only can be made, if admin is in specmode or dead.

Version 2.1:
- admin_ss_ip <Player> will get banned by his IP and not SteamID

Feature:
- After using the command "admin_ss <target>", console is closed and the admin
  is switched to target for spectating target in first person mode.
- Msg1 and Msg2 (to be edited in *.sma!) appear on client's screen.
- A screenshot will be taken for the client !AND! admin at the same time.
- After the screenshot, client will be banned and an registration is created in screenshot.cfg.
- The screenshot.cfg can be used as a banned.cfg and could be executed in server.cfg.
- The screenshot.cfg can be displayed with "admin_ss_list <lineno.>".
- Using command "admin_ss_del <lineno.>", ban of player will be removed in screenshot.cfg and i hope,
  in banned.cfg too.
*/



#include <core>
#include <console>
#include <string>
#include <admin>
#include <adminlib>

#define ACCESS_SS 128

new STRING_VERSION[MAX_DATA_LENGTH] = "2.1";

/////////////////////////////
// PLEASE EDIT THESE LINES //
/////////////////////////////
new Database[MAX_TEXT_LENGTH]="addons/adminmod/config/screenshot.cfg";
new Msg1[MAX_TEXT_LENGTH]="[ADMIN] A screenshot of you is taken. Please send it immediately to 'xyz@web.de'!";
new Msg2[MAX_TEXT_LENGTH]="[ADMIN] If you don't send it within '30' minutes, you will be banned permanently!";
/////////////////////////////

new TargetName[MAX_NAME_LENGTH];
new AdminName[MAX_NAME_LENGTH];
new iBanType;


public plugin_init() {
        plugin_registerinfo("Takes SS from target","Just for fun.",STRING_VERSION);
        plugin_registercmd("admin_ss","admin_ss",ACCESS_SS,"admin_ss <target>: Takes SS from target.");
        plugin_registercmd("admin_ss_ip","admin_ss",ACCESS_SS,"admin_ss_ip <target>: Takes SS from target.");
        plugin_registercmd("admin_ss_list","admin_ss_list",ACCESS_SS,"admin_ss_list <line>: displays a list from whom screenshots are made, starting at 'line'");
        plugin_registercmd("admin_ss_del","admin_ss_del",ACCESS_SS,"admin_ss_del <line>: deletes entry at specific line number.");
        return PLUGIN_CONTINUE;
}

public admin_ss(HLCommand,HLData,HLUserName,UserIndex) {
        new Command[MAX_COMMAND_LENGTH];
        new Data[MAX_DATA_LENGTH];
        new Text[MAX_TEXT_LENGTH];
        new iDead;
        new iTargetIndex;

        convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
        convert_string(HLData,Data,MAX_DATA_LENGTH);
        
        if(strcmp(Command,"admin_ss_ip")==0 || getvar("sv_lan") != 0){
		iBanType = bBanByIP;
	}
                
        playerinfo(UserIndex,AdminName,MAX_NAME_LENGTH,_,_,_,iDead);
        
        /*Admin dead?*/
        if(!iDead){
        	snprintf(Text,MAX_TEXT_LENGTH,"[ADMIN-SS] Sorry. You are not 'dead'! You can't make a screenshot of %s!",Data);
        	selfmessage(Text);
        	return PLUGIN_HANDLED;
        }
        /*Command still in use?*/
        if(strlen(TargetName)!=0 && strlen(AdminName)!=0){
        	snprintf(Text,MAX_TEXT_LENGTH,"[ADMIN-SS] Sorry. admin_ss '%s' in use by '%s'. Please wait moment!",TargetName,AdminName);
        	selfmessage(Text);
        	return PLUGIN_HANDLED;
        }
        
        /*Target exists?*/
        if (check_user(Data) == 1) {
                get_username(Data,TargetName,MAX_NAME_LENGTH);
                get_userindex( TargetName, iTargetIndex );
                playerinfo(iTargetIndex,TargetName,MAX_NAME_LENGTH,_,_,_,iDead);
                /*Useless screenshot, if target is dead?*/
                if(iDead){
                	snprintf(Text,MAX_TEXT_LENGTH,"[ADMIN-SS] Sorry. '%s' is 'dead'! It would be a useless screenshot!",TargetName);
        		selfmessage(Text);
        		return PLUGIN_HANDLED;
        	}
        	/*Target immune?*/
                if(check_immunity(TargetName)!=0) {
                        snprintf(Text, MAX_TEXT_LENGTH, "Laf. You can't ss %s, you silly bear.", TargetName);
                        selfmessage(Text);
                        return PLUGIN_HANDLED;
                }
                /*Ok. All is fine. Lead the admin to target*/
        	execclient(AdminName,"escape");
        	snprintf(Text,MAX_TEXT_LENGTH,"follow ^"%s^"",TargetName);
        	execclient(AdminName,Text);
        	execclient(AdminName,"specmode 4");
        	//need a delay to close the console and to switch admin in first-person-mode!
		set_timer("prepare_screenshot",1,0);
        }
        else {
                selfmessage("Unrecognized player: ");
                selfmessage(Data);
        }
        return PLUGIN_HANDLED;
}

public prepare_screenshot(Timer,Repeat,HLUser,HLParam) {
	new Text[MAX_TEXT_LENGTH];
	new ST[MAX_DATA_LENGTH];
	new Banid[MAX_TEXT_LENGTH];
	new PlayerAuthID[MAX_AUTHID_LENGTH];
	new AdminAuthID[MAX_AUTHID_LENGTH];
	
	//new added
	new sIP[MAX_NAME_LENGTH];
	get_userIP(TargetName, sIP, MAX_NAME_LENGTH);
	
	/*flood target with msg1 and msg2 to verify that it is the correct screenshot he will send!*/
	messageex(TargetName, Msg1, print_chat);
	messageex(TargetName, Msg2, print_chat);
	messageex(TargetName, Msg1, print_chat);
	messageex(TargetName, Msg2, print_chat);
	messageex(TargetName, Msg1, print_chat);
	messageex(TargetName, Msg2, print_chat);
	messageex(TargetName, Msg1, print_chat);
	messageex(TargetName, Msg2, print_chat);
	messageex(TargetName, Msg1, print_chat);
	messageex(TargetName, Msg2, print_chat);
	messageex(TargetName, Msg1, print_console);
	messageex(TargetName, Msg2, print_console);
	
	/*Admin and target are forced to make a screenshot*/
	execclient(TargetName, "snapshot");
	execclient(AdminName, "snapshot");
	snprintf(Text,MAX_TEXT_LENGTH,"[ADMIN-SS] Screenshot succeeded for you and player: %s! Ban in 2 sec.!",TargetName);
	messageex(AdminName,Text,print_chat);
	
	/*Prepare database registration*/
	get_userAuthID(TargetName,PlayerAuthID);
	get_userAuthID(AdminName,AdminAuthID);
	servertime(ST, MAX_DATA_LENGTH, "%d.%m.%y %H:%M:%S");
	
	/*create ban-register like in banned.cfg*/
	snprintf(Banid,MAX_TEXT_LENGTH,"banid 0.0 %s //",PlayerAuthID);
	
	/*ALT+Numpad 169 == . Nice delimiter, imo :)*/
	snprintf(Text,MAX_TEXT_LENGTH,"%s %s  %s  %s  %s  %s  %s",Banid,TargetName,PlayerAuthID,ST,AdminName,AdminAuthID,sIP);
	writefile(Database,Text,-1);
	
	//need a delay for ban, because message should appear on target's screen
	set_timer("targetban",2,0);
}

public targetban(Timer,Repeat,HLUser,HLParam) {
	/*ban target by IP*/
	ban(TargetName,0,iBanType);
	
	/*command can be used again*/
	strinit(TargetName);
	strinit(AdminName);
	iBanType=0;
}

public admin_ss_list(HLCommand,HLData,HLUserName,UserIndex) {
	new Text[MAX_TEXT_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new i;
	new iLine;
	new filelines;
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	iLine=strtonum(Data);
	
	selfmessage("[ADMIN-SS]");
	snprintf(Text,MAX_TEXT_LENGTH,"--- READING FILE: %s ---",Database);
	selfmessage(Text);
	if(fileexists(Database)){
		filelines=filesize(Database);
		if(iLine > filelines || iLine < 0){
			selfmessage("");
			selfmessage("Line not found!");
			selfmessage("");
			selfmessage("----------------------");
			snprintf(Text,MAX_TEXT_LENGTH,"Total lines: %i",filelines);
			selfmessage(Text);
			return PLUGIN_CONTINUE;
		}
		/*starting in line 1*/
		if(iLine==0){
			iLine=1;
		}
		for(i=iLine;i<iLine+10;i++){
			if(i>filelines){
				i--;
				break;
			}
			readfile(Database,Data,i,MAX_TEXT_LENGTH);
			snprintf(Text,MAX_TEXT_LENGTH,"%i. %s",i,Data);
			selfmessage(Text);
		}
		selfmessage("");
		selfmessage("----------------------");
		snprintf(Text,MAX_TEXT_LENGTH,"Line: %i to %i",iLine,i);
		selfmessage(Text);
		snprintf(Text,MAX_TEXT_LENGTH,"Total Lines: %i",filelines);
		selfmessage(Text);
	}else{
		selfmessage("[ADMIN-SS]");
		snprintf(Text,MAX_TEXT_LENGTH,"File %s not found!",Database);
		selfmessage(Text);
		selfmessage("");
		selfmessage("----------------------");
	}
	return PLUGIN_HANDLED;
}

public admin_ss_del(HLCommand,HLData,HLUserName,UserIndex) {
	new Text[MAX_TEXT_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new BanID[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	new PlayerName[MAX_NAME_LENGTH];
	new PlayerAuthID[MAX_AUTHID_LENGTH];
	new iLine;
	new filelines;
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	iLine=strtonum(Data);
	
	selfmessage("[ADMIN-SS]");
	snprintf(Text,MAX_TEXT_LENGTH,"--- READING FILE: %s ---",Database);
	selfmessage(Text);
	if(fileexists(Database)){
		filelines=filesize(Database);
		if(iLine > filelines || iLine < 0){
			selfmessage("");
			selfmessage("Line not found!");
			selfmessage("");
			selfmessage("----------------------");
			snprintf(Text,MAX_TEXT_LENGTH,"Total lines: %i",filelines);
			selfmessage(Text);
			return PLUGIN_CONTINUE;
		}
		readfile(Database,Data,iLine,MAX_TEXT_LENGTH);
		strsep(Data,"  ", BanID,MAX_DATA_LENGTH,PlayerName,MAX_NAME_LENGTH,PlayerAuthID,MAX_AUTHID_LENGTH);
		/*delete registration in screenshot.cfg*/
		snprintf(Text,MAX_TEXT_LENGTH,"//Deleted by: %s -- %s",User,Data);
		writefile(Database,Text,iLine);
		/*i hope, that it will remove the registration in banned.cfg!*/
		unban(PlayerAuthID);
		snprintf(Text,MAX_TEXT_LENGTH,"%i",iLine);
		/*display admin_ss_list to admin, starting at line he gives!*/
		plugin_exec("admin_ss_list",Text);
	}else{
		selfmessage("[ADMIN-SS]");
		snprintf(Text,MAX_TEXT_LENGTH,"File %s not found!",Database);
		selfmessage(Text);
		selfmessage("");
		selfmessage("----------------------");
	}
	return PLUGIN_HANDLED;
}
